package 
{
	import flash.display.Bitmap;
	import flash.display.BitmapData;
	import flash.display.Sprite;
	import flash.events.Event;
    import flash.filters.DropShadowFilter;
	import flash.filters.BitmapFilterQuality;
	/*
	*Le principe des courbes de lissajou est basé sur la composition de 2 mouvements sinusoidales
	*Un mouvement d'aller-retour horizontal
	*Un mouvement d'aller-retour vertical
	*La difference entre les vitesses d'implémentation de l'angle vont créer des courbes très différentes
	*La difference des rayons d'angle également.
	*/
	public class Lissajou extends Sprite
	{
		private var background:Bitmap;
		private var data:BitmapData;
		private var horizontal_support:Sprite;
		private var horizontal_angle:Number =0;
		private var vertical_support:Sprite;
		private var vertical_angle:Number = 0;
		private var canevas:Sprite;
		private var vitesseH:Number;
		private var vitesseV:Number;
		private var vitesseG:Number;
		private var vitesseF:Number;

		public function Lissajou()
		{
			data = new BitmapData(900,880,false,0xffffff);
			background = new Bitmap(data);

			addChild(background);
			canevas = new Sprite();
			addChild(canevas);

			/*
			 * PARAMETRAGE DES VITESSES 
			 * EN MODIFIANT CES PARAMETRES VOUS AUREZ DES COURBES VARIANTES
			 */
			vitesseH = 4.13;
			vitesseV =1.3;

			vitesseG =9.0;
			vitesseF =2.2;

			buildHorizontalMovement();
			buildHorizontalMovement(1);
			buildHorizontalMovement(2);
			
		
		}
		private function buildHorizontalMovement(type:Number = 3):void
		{
			horizontal_support = new Sprite();
			horizontal_support.x= -40;
			horizontal_support.y= 300;

			canevas.addChild(horizontal_support);
			
			switch(type){
				case 1:
					horizontal_support.addEventListener(Event.ENTER_FRAME,horizontal_enter2_handler);
				break;
				case 2:
				  horizontal_support.addEventListener(Event.ENTER_FRAME,horizontal_enter3_handler);
				break;
				
				default:
					horizontal_support.addEventListener(Event.ENTER_FRAME,horizontal_enter_handler);
				}

			buildVerticalMovement(horizontal_support);
		}
		private function horizontal_enter_handler(e:Event):void
		{
			horizontal_angle+=vitesseF;
			e.currentTarget.x = Math.sin(horizontal_angle*Math.PI/1090)*260 + 300;
		}
		
		private function horizontal_enter2_handler(e:Event):void
		{
			horizontal_angle+=vitesseH;
			e.currentTarget.x = Math.sin(horizontal_angle*Math.PI/1010)*120 + 290;
		}
		private function horizontal_enter3_handler(e:Event):void
		{
			horizontal_angle+=vitesseG;
			e.currentTarget.x =- Math.sin(horizontal_angle*Math.PI/1050)*210+ 290;
		}
		
		
		private function buildVerticalMovement(clip:Sprite):void
		{
			vertical_support = new Sprite();
			vertical_support.graphics.beginFill(0xffffff,.5);
			vertical_support.graphics.lineStyle(6,0x000000,.4);
			vertical_support.graphics.drawCircle(1,1,30);
			vertical_support.graphics.endFill();

			clip.addChild(vertical_support);
			

			vertical_support.addEventListener(Event.ENTER_FRAME,vertical_enter_handler);
		}
		private function vertical_enter_handler(e:Event):void
		{
			vertical_angle+=vitesseV;
			e.currentTarget.y = Math.sin(vertical_angle*Math.PI/1000)*360;
			data.draw(canevas);
		}
	}
}